
import {SimpleTestLauncherConfigBuilder} from './test-launcher-config-builder';

export class SimpleProjectConfigBuilder {

  constructor(parent?: SimpleTestLauncherConfigBuilder);

  /**
   * The configuration group name
   */
  public _subConfigurationGroupName: string;

  /**
   * Returns the default configuration
   */
  protected _defaultConfiguration(): Object;

  /**
   * Clear the configuration
   */
  public clear(): SimpleProjectConfigBuilder;

  /**
   * Set the root directory
   * @param [value] The new value. Set undefined to set put the default value
   */
  public rootDirectoryPath(value?: string): SimpleProjectConfigBuilder;

  /**
   * Returns the parent builder
   */
  public parentBuilder(): SimpleTestLauncherConfigBuilder;

  /**
   * Generate the object configuration
   */
  public build(): Object;
}
