
import {SimpleTestLauncherConfigBuilder} from './test-launcher-config-builder';

export class SimpleTestConfigBuilder {

  constructor(parent?: SimpleTestLauncherConfigBuilder);

  /**
   * The configuration group name
   */
  public _subConfigurationGroupName: string;

  /**
   * Returns the default configuration
   */
  protected _defaultConfiguration(): Object;

  /**
   * Clear the configuration
   */
  public clear(): SimpleTestConfigBuilder;

  /**
   * Set the spec directory
   * @param [value] The new value. Set undefined to set put the default value
   */
  public specDirPath(value?: string|null): SimpleTestConfigBuilder;

  /**
   * Set the test type
   * @param [value] The new value. Set undefined to set put the default value
   */
  public type(value?: string|null): SimpleTestConfigBuilder;

  /**
   * Set the type to unit test
   * @see type
   */
  public unitTest(): SimpleTestConfigBuilder;

  /**
   * Set the type to integration test
   * @see type
   */
  public integrationTest(): SimpleTestConfigBuilder;

  /**
   * Set the type to system test
   * @see type
   */
  public systemTest(): SimpleTestConfigBuilder;

  /**
   * Set the native configuration
   * @param [value] The new value. Set undefined to set put the default value
   */
  public nativeConfiguration(value?: Object|null): SimpleTestConfigBuilder;

  /**
   * Add a new spec filter
   * @param [value] The filter to add
   */
  public withSpecFileFilter(value?: Function|string|RegExp): SimpleTestConfigBuilder;

  /**
   * Returns the parent builder
   */
  public parentBuilder(): SimpleTestLauncherConfigBuilder;

  /**
   * Generate the object configuration
   */
  public build(): Object;
}
