/**
 * Test launcher
 */
export class SimpleTestLauncher {

  constructor();

  /**
   * The current state
   */
  public currentState: string;

  /**
   * Returns the configuration
   */
  public getConfiguration(): Object;

  /**
   * Returns the project root path directory
   */
  public getProjectRootDirPath(): string;

  /**
   * Returns the test type
   */
  public getTestType(): string;

  /**
   * Returns the reports root directory path
   */
  public getRootReportPath(): string;

  /**
   * Returns the root report test path
   */
  public getRootReportTestPath(): string;

  /**
   * Returns the test spec directory path
   */
  public getTestSpecDirPath(): string;

  /**
   * Returns if the coverage is enabled or not
   */
  public isCodeCoverageEnabled(): boolean;

  /**
   * Returns the input configuration
   */
  public getInputConfiguration(): Object;

  /**
   * Returns if the object is ready or not
   */
  public isReady(): boolean;

  /**
   * Returns if the test is running
   */
  public isRunning(): boolean;

  /**
   * Configure the launcher
   * @param options
   */
  public configure(options: Object): Promise<void>;

  /**
   * Start to run the tests
   */
  public start(): Promise<void>;

  /**
   * Run the tests
   */
  public run(): Promise<void>;
}
